<!DOCTYPE HTML PUBLIC "-//IETF//DTD HTML 3.0//EN" "html.dtd">
<HTML>

<HEAD>
<TITLE>PHP Firewall Generator -- Start Here</TITLE>
<?php

#############################################################################
#
# $Id: index.php3,v 1.9 1999/12/16 20:06:04 del Exp $
#
# PHP Firewall Generator by Del <del@babel.com.au>.  Original coding ideas
# from IPCHAINS-FIREWALL V1.6.2m by Ian Hall-Beyer (manuka@nerdherd.net)
# and various others.
#
# (C) Del under the GPL.
#
#############################################################################

#
# Define some constants.
#

$CONF="/var/lib/phpfwgen";

#############################################################################
#
# Read in all definitions.
#
#############################################################################

$interfaces = file("$CONF/interfaces");

$protocolr = file("/etc/protocols");
while ( list( $key, $val ) = each($protocolr) ) {
  #
  # Skip blank lines and comments
  #
  if ( strlen($val) < 5 ) continue;
  if ( substr($val, 0, 1) == "#" ) continue;
  $exploded = preg_split ("/[\s\/]+/", $val);
  $protocols[$exploded[0]] = intval($exploded[1]);
  $port = intval($exploded[1]);
}
asort($protocols);

$servicer = file("/etc/services");
# Stuff at the top ...
$services["HIPORTS/udp"] = "1024:65535";
$services["HIPORTS/tcp"] = "1024:65535";
while ( list($key,$val ) = each($servicer) ) {
  #
  # Skip blank lines and comments
  #
  if ( strlen($val) < 5 ) continue;
  if ( substr($val, 0, 1) == "#" ) continue;
  $exploded = preg_split ("/[\s\/]+/", $val);
  $service = $exploded[0];
  $port = intval($exploded[1]);
  $proto = $exploded[2];
  $services["$service/$proto"] = $port;
}
asort($services);
#
# Add the ICMP types
#
$icmpp = popen("/sbin/ipchains -h icmp", "r");
# Discard first 3 lines of header
$buffer = fgets($icmpp, 255);
$buffer = fgets($icmpp, 255);
$buffer = fgets($icmpp, 255);
# Slurp the rest in
while (!feof($icmpp)) {
  $buffer = fgets($icmpp, 255);
  $buffer = trim($buffer);
  $buffer = ereg_replace(" .*$","",$buffer);
  if (empty($buffer)) continue;
  $services["$buffer/icmp"] = "ICMP";
}
$term = pclose($icmpp);

function read_config() {
  global $CONF;

  $configr = file("$CONF/config");
  while ( list($key,$val ) = each($configr) ) {
    #
    # Skip blank lines and comments
    #
    if ( strlen($val) < 5 ) continue;                                               if ( substr($val, 0, 1) == "#" ) continue;
    $exploded = explode (" ", $val);
    $config[$exploded[0]] = chop($exploded[1]);
  }
  return $config;
}

function write_config($config) {
  global $CONF;

  $conffile = fopen ("$CONF/config","w+");
  reset($config);
  while ( list($key,$val) = each($config) ) {
    fwrite ($conffile, "$key $val\n");
  }
  fclose($conffile);
}

function read_objects() {
  global $CONF;

  $netobjectr = file("$CONF/netobjects");
  while ( list($key,$val ) = each($netobjectr) ) {
    #
    # Skip blank lines and comments
    #
    if ( strlen($val) < 5 ) continue;
    if ( substr($val, 0, 1) == "#" ) continue;
    $exploded = explode (" ", $val);
    $netobjects[$exploded[0]] = "$exploded[1] $exploded[2] " . chop($exploded[3]);
  }
  return $netobjects;
}

function write_objects($netobjects) {
  global $CONF;

  $objfile = fopen ("$CONF/netobjects","w+");
  reset($netobjects);
  while ( list($key,$val) = each($netobjects) ) {
    fwrite ($objfile, "$key $val\n");
  }
  fclose($objfile);
}

function read_rulesets() {
  global $CONF;

  $ruler = file("$CONF/rulesets");
  $rulekey = 100;
  while ( list( $key, $val ) = each($ruler) ) {
    #
    # Skip blank lines and comments
    #
    if ( strlen($val) < 5 ) continue;
    if ( substr($val, 0, 1) == "#" ) continue;
    $rules[$rulekey] = chop($val);
    $rulekey += 100;
  }
  return $rules;
}

function write_rulesets($rules) {
  global $CONF;

  $rulefile = fopen ("$CONF/rulesets","w+");
  reset($rules);
  while ( list($key,$val) = each($rules) ) {
    fwrite ($rulefile, "$val\n");
  }
  fclose ($rulefile);
}

$config = read_config();
$netobjects = read_objects();
$rules = read_rulesets();

#############################################################################
#
# Form/Submit handler.
#
#############################################################################

#
# Check if there was a submission.
#
while ( is_array($HTTP_POST_VARS)
     && list($key, $val) = each($HTTP_POST_VARS)) {
  switch ($key) {

    #
    # Create a new network object.
    #
    case "createobject_x":
      if (empty($newobjectname) || empty($newnetaddr) || empty($newnetmask)) {
        break;
      }
      $netobjects[$newobjectname] = "$newnetaddr $newnetmask $newmasq";
      write_objects($netobjects);
    break;

    #
    # Delete a network object.
    #
    case "delobject_x":
      unset($netobjects[$objectname]);
      write_objects($netobjects);
    break;

    #
    # Create a firewall rule.
    #
    case "createrule_x":
      if (empty($newrulekey)) {
        $newrulekey = 32767;
      }
      if ($newport != "ALL") {
        $exploded = preg_split ("/[\s\/]+/", $newport);
        if ($newproto == "ALL") $newproto = $exploded[1];
        if ($newproto != $exploded[1]) break;
        $newport = $exploded[0];
      }
      $rules[$newrulekey] = "$source $dest $newproto $newport $action $log";
      ksort($rules);
      write_rulesets($rules);
      $rules = read_rulesets();
    break;

    #
    # Delete a firewall rule.
    #
    case "delrule_x":
      unset($rules[$rulekey]);
      write_rulesets($rules);
      $rules = read_rulesets();
    break;

    #
    # Config stuff.
    #
    case "showinterfaces":
      $config[SHOW_INTERFACES] = "YES";
      write_config($config);
    break;
    case "hideinterfaces":
      $config[SHOW_INTERFACES] = "NO";
      write_config($config);
    break;
    case "shownetobjects":
      $config[SHOW_NETOBJECTS] = "YES";
      write_config($config);
    break;
    case "hidenetobjects":
      $config[SHOW_NETOBJECTS] = "NO";
      write_config($config);
    break;
    case "showrules":
      $config[SHOW_RULES] = "YES";
      write_config($config);
    break;
    case "hiderules":
      $config[SHOW_RULES] = "NO";
      write_config($config);
    break;
    case "showprotocols":
      $config[SHOW_PROTOCOLS] = "YES";
      write_config($config);
    break;
    case "hideprotocols":
      $config[SHOW_PROTOCOLS] = "NO";
      write_config($config);
    break;
    case "showservices":
      $config[SHOW_SERVICES] = "YES";
      write_config($config);
    break;
    case "hideservices":
      $config[SHOW_SERVICES] = "NO";
      write_config($config);
    break;

    default:
      # print "$key ";
    break;
  } # end switch
} # end while
?>

</HEAD>

<BODY BGCOLOR="#FFFFFF">

<TABLE BORDER=0 CELLSPACING=2 CELLPADDING=4>

<TR><TD>&nbsp;</TD><TD><HR></TD></TR>

<TR><TD ALIGN=LEFT VALIGN=TOP><B>Introduction</B></TD>
<TD>

<A HREF="http://www.php.net/"><IMG SRC="phplogo1.gif" ALT="Powered by PHP" ALIGN=RIGHT BORDER=0></A>
This is the first (very primitive) cut of a PHP based firewall script
generator for ipchains based firewalls on Linux.  More help text coming
soon, and perhaps someone would like to do some fancier graphics for
me because I'm really hopeless at it.
<P>
(c)
<A HREF="mailto:del@babel.com.au">Del</A>
1999 under the
<A HREF="http://www.gnu.org/copyleft/gpl.html">GPL</A>
<P>

Here are some very basic instructions:
<P>

<UL>
<LI>Make sure that your /etc/services file and /etc/protocols file
are correct.  You can't define any rules in your firewall for services
or protocols that don't exist in these files.
<LI>Make sure the interface list is correct.  This is for reference
purposes only and isn't actually used anywhere in the program, but
it does give you a sanity check to make sure that everything is defined
the way it should be.
<LI>Enter all of your network objects.
<LI>Enter your firewall rules.
<LI>Once your firewall rules are entered, check the script at the bottom
of the page.  You can cut and paste this into a text editor and use it
as your firewall script.
</UL>

TODO:
<P>

<UL>
<LI>Better graphics.  Help wanted!!
<LI>Generate the script in a file, and install it automatically.
<LI>Mail the script to you.
<LI>Port forwarding via ipmasqadm (that's what the redirectors file
is for).
<LI>Support for
<A HREF="http://netfilter.kernelnotes.org/">NAT/iptables/ipfilter</A>
<LI>Currently a rule that allows all outgoing traffic on all ports
also allows all incoming traffic on all ports (for TCP responses).
It'd be better to allow only incoming traffic on the ports that were
actually in use for outgoing socket connections, but this isn't possible
in ipchains.  Some scripts do this by allowing incoming connections on
the high ports (1024:65535) but this is unsuitable since many programs
now bind to these ports for incoming connections (eg: most databases),
and also these ports are often used for hacks (eg: NetBus, BackOrifice).
Find a good solution to this problem!
<LI>The above problem is fixed for TCP by using the '! -y' options,
but not for UDP.
</UL>

CREDITS:
<P>

I got some ideas from various places, including Godot's Muse and
IPCHAINS-FIREWALL V1.6.2m by Ian Hall-Beyer (manuka@nerdherd.net)
<P>

<HR></TD></TR>

<?php
#############################################################################
#
# Interfaces.
#
#############################################################################
?>

<TR><TD ALIGN=LEFT VALIGN=TOP><B>Interfaces</B>
<BR>
<FORM NAME="button" METHOD="POST" ACTION="index.php3">
<?php if ($config[SHOW_INTERFACES] == "YES") { ?>
  <INPUT TYPE="SUBMIT" NAME="hideinterfaces" VALUE="Hide">
<?php } else { ?>
  <INPUT TYPE="SUBMIT" NAME="showinterfaces" VALUE="Show">
<?php } ?>
</FORM>
</TD>

<TD>

The interface list is for reference purposes only.  You cannot add or
delete interfaces here.  To add or delete interfaces, insert or remove
network adapters / drivers from your machine, and use the Red Hat
"netcfg" program.
<P>

<?php if ($config[SHOW_INTERFACES] == "YES") { ?>

<TABLE BORDER=0 BGCOLOR="#EEEEEE" CELLSPACING=2 CELLPADDING=4>
  <TR ALIGN=LEFT VALIGN=TOP><TD><B>Interface Name</B></TD></TR>

<?php

#
# Print all of the interface definitions.
#
function print_interface ($interface) {
  print "<TR VALIGN=TOP ALIGN=LEFT><TD>$interface</TD></TR>\n";
}

if (is_array($interfaces)) {
  reset($interfaces);
  array_walk( $interfaces, 'print_interface' );
}

?>

</TABLE>

<?php } ?>

<HR></TD></TR>

<?php
#############################################################################
#
# Network Objects.
#
#############################################################################
?>

<TR><TD ALIGN=left VALIGN=top><B>Network Objects</B>
<BR>
<FORM NAME="button" METHOD="POST" ACTION="index.php3">
<?php if ($config[SHOW_NETOBJECTS] == "YES") { ?>
  <INPUT TYPE="SUBMIT" NAME="hidenetobjects" VALUE="Hide">
<?php } else { ?>
  <INPUT TYPE="SUBMIT" NAME="shownetobjects" VALUE="Show">
<?php } ?>
</FORM>
</TD>
<TD>

Enter all of your network objects here.  For example, make sure that
all of your internal networks are defined.  If there are external
hosts or networks that you need to define rules for, add them here.
You can add an object definition in the form at the bottom of the
object list.
<P>

The network mask can be entered as a dotted netmask (eg: 255.255.255.0)
or as a number of network bits to include in the mask (eg: 24).  For
example, the values 255.255.255.255 and 32 are identical.
<P>

<?php if ($config[SHOW_NETOBJECTS] == "YES") { ?>
<TABLE BORDER=0 BGCOLOR="#EEEEEE" CELLSPACING=2 CELLPADDING=2>
  <TR ALIGN=LEFT VALIGN=MIDDLE>
    <TD><B>Object Name</B></TD>
    <TD><B>Network Address</B></TD>
    <TD><B>Network Mask</B></TD>
    <TD><B>Masquerade</B></TD>
    <TD><B>Submit</B></TD>
  </TR>

<?php

#
# Print all of the network object definitions.
#
function print_netobject ($netobject, $value) {
  list ($address, $mask, $masq) = preg_split ("/[\s]+/", $value);
  print "<TR ALIGN=LEFT VALIGN=MIDDLE>";
  print "<TD>$netobject</TD><TD>$address</TD><TD>$mask</TD><TD>$masq</TD>";
  print "<TD>";
  print "<FORM NAME=\"rmobject\" METHOD=\"POST\" ACTION=\"index.php3\">";
  print "<INPUT TYPE=\"HIDDEN\" NAME=\"objectname\" VALUE=\"$netobject\">";
  print "<INPUT TYPE=IMAGE SRC=mini-cross.gif NAME=delobject BORDER=0>";
  print "</FORM>";
  print "</TD>";
  print "</TR>\n";
}

if (is_array($netobjects)) {
  reset($netobjects);
  while ( list($key,$val) = each($netobjects) ) {
    print_netobject ($key, $val);
  }
}

#
# A form to add a network object.
#
?>

<FORM NAME="addobject" METHOD="POST" ACTION="index.php3">
  <TR ALIGN=LEFT VALIGN=MIDDLE>
    <TD><INPUT TYPE="TEXT" NAME="newobjectname" SIZE=12 MAXLENGTH=32 VALUE=""></TD>
    <TD><INPUT TYPE="TEXT" NAME="newnetaddr" SIZE=12 MAXLENGTH=32 VALUE=""></TD>
    <TD><INPUT TYPE="TEXT" NAME="newnetmask" SIZE=12 MAXLENGTH=32 VALUE=""></TD>
    <TD><SELECT NAME="newmasq">
        <OPTION SELECTED>YES
        <OPTION>NO
        </SELECT>
    </TD>
    <TD><INPUT TYPE=IMAGE SRC=mini-tick.gif NAME=createobject BORDER=0></TD>
  </TR>
</FORM>

</TABLE>
<?php } ?>

<HR></TD></TR>

<?php
#############################################################################
#
# Firewall Rules.
#
#############################################################################
?>

<TR><TD ALIGN=left VALIGN=top><B>Firewall Rules</B>
<FORM NAME="button" METHOD="POST" ACTION="index.php3">
<?php if ($config[SHOW_RULES] == "YES") { ?>
  <INPUT TYPE="SUBMIT" NAME="hiderules" VALUE="Hide">
<?php } else { ?>
  <INPUT TYPE="SUBMIT" NAME="showrules" VALUE="Show">
<?php } ?>
</FORM>
</TD>
<TD>

Enter your firewall rules here.  You need to enter the following
for each rule:
<UL>
<LI><B>Rule Number</B>: This defines where the rule is entered into
the list.  For example, to enter a new rule between 100 and 200,
number it "150".  The rules will be re-numbered on each iteration
of the firewall, so you can continue entering rules between each
new pair of rules.  If you leave this blank then the rule will go
at the end of the rule set.
<LI><B>Source</B>: Select a source network object (where the packet
is coming from).
<LI><B>Destination</B>: Select a destination network object (where the packet
is going to).
<LI><B>Protocol</B>: Select a network protocol, or ALL for all protocols.
<LI><B>Service</B>: Select a network port, or ALL for all ports.  Note that
most ports will also define a protocol, eg: telnet/tcp is for the tcp
protocol.
<LI><B>Action</B>: This will be ACCEPT or DENY.
<LI><B>Log</B>: YES to log the packet, NO to not bother logging it.
</UL>

<?php if ($config[SHOW_RULES] == "YES") { ?>
<TABLE BORDER=0 BGCOLOR="#EEEEEE" CELLSPACING=2 CELLPADDING=4>
  <TR ALIGN=LEFT VALIGN=MIDDLE>
    <TD><B>Rule Number</B></TD>
    <TD><B>Source</B></TD>
    <TD><B>Destination</B></TD>
    <TD><B>Protocol</B></TD>
    <TD><B>Service</B></TD>
    <TD><B>Action</B></TD>
    <TD><B>Log</B></TD>
    <TD><B>Submit</B></TD>
  </TR>

<?php

#
# Print all of the firewall rules.
#
function print_rule ($key, $rule) {
  list ($source, $dest, $proto, $port, $action, $log) = preg_split ("/[\s]+/", $rule);
  print "<TR ALIGN=LEFT VALIGN=MIDDLE>";
  print "<TD>$key</TD>";
  print "<TD>$source</TD><TD>$dest</TD><TD>$proto</TD><TD>$port</TD>";
  print "<TD>$action</TD><TD>$log</TD>";
  print "<TD>";
  print "<FORM NAME=\"rmrule\" METHOD=\"POST\" ACTION=\"index.php3\">";
  print "<INPUT TYPE=\"HIDDEN\" NAME=\"rulekey\" VALUE=\"$key\">";
  print "<INPUT TYPE=IMAGE SRC=mini-cross.gif NAME=delrule BORDER=0>";
  print "</FORM>";
  print "</TD>";
  print "</TR>\n";
}

if (is_array($rules)) {
  reset($rules);
  while ( list($key,$val) = each($rules) ) {
    print_rule ($key, $val);
  }
}

#
# A form to add a rule.
#
?>

<FORM NAME="addrule" METHOD="POST" ACTION="index.php3">
  <TR ALIGN=LEFT VALIGN=MIDDLE>
    <TD><INPUT TYPE="TEXT" NAME="newrulekey" SIZE=12 MAXLENGTH=32 VALUE=""></TD>
    <TD><SELECT NAME="source">
<?php
reset($netobjects);
while ( list($key,$val) = each($netobjects) ) {
  if ($key == "ALL") {
    print "<OPTION SELECTED>$key\n";
  } else {
    print "<OPTION>$key\n";
  }
}
?>
        </SELECT>
    </TD>
    <TD><SELECT NAME="dest">
<?php
reset($netobjects);
while ( list($key,$val) = each($netobjects) ) {
  if ($key == "ALL") {
    print "<OPTION SELECTED>$key\n";
  } else {
    print "<OPTION>$key\n";
  }
}
?>
        </SELECT>
    </TD>
    <TD><SELECT NAME="newproto">
        <OPTION SELECTED>ALL
<?php
reset($protocols);
while ( list($key,$val) = each($protocols) ) {
  print "<OPTION>$key\n";
}
?>
        </SELECT>
    </TD>
    <TD><SELECT NAME="newport">
        <OPTION SELECTED>ALL
<?php
reset($services);
while ( list($key,$val) = each($services) ) {
  print "<OPTION>$key\n";
}
?>
        </SELECT>
    </TD>
    <TD><SELECT NAME="action">
        <OPTION SELECTED>ACCEPT
        <OPTION>DENY
        </SELECT>
    </TD>
    <TD><SELECT NAME="log">
        <OPTION SELECTED>YES
        <OPTION>NO
        </SELECT>
    </TD>
    <TD><INPUT TYPE=IMAGE SRC=mini-tick.gif NAME=createrule BORDER=0></TD>
  </TR>
</FORM>

</TABLE>
<?php } ?>

<HR></TD></TR>

<?php
#############################################################################
#
# Protocols.
#
#############################################################################
?>

<TR><TD ALIGN=left VALIGN=top><B>Protocols (Reference)</B>
<FORM NAME="button" METHOD="POST" ACTION="index.php3">
<?php if ($config[SHOW_PROTOCOLS] == "YES") { ?>
  <INPUT TYPE="SUBMIT" NAME="hideprotocols" VALUE="Hide">
<?php } else { ?>
  <INPUT TYPE="SUBMIT" NAME="showprotocols" VALUE="Show">
<?php } ?>
</FORM>
</TD>
<TD>

The protocols table is for reference only.  You cannot add or delete
protocols here.  Please edit /etc/protocols if you need to add or
change any of these.
<P>

<?php if ($config[SHOW_PROTOCOLS] == "YES") { ?>
<TABLE BORDER=0 BGCOLOR="#EEEEEE" CELLSPACING=2 CELLPADDING=4>
  <TR ALIGN=LEFT VALIGN=TOP>
    <TD><B>Protocol Name</B></TD>
    <TD><B>Protocol Number</B></TD>
  </TR>

<?php

#
# Print all of the protocol definitions.
#
function print_protocol ($proto,$num) {
  print "<TR VALIGN=MIDDLE ALIGN=LEFT>";
  print "<TD>$proto</TD><TD>$num</TD></TR>\n";
}

reset($protocols);
while ( list($key,$val) = each($protocols) ) {
  print_protocol ($key, $val);
}

?>

</TABLE>
<?php } ?>

<HR></TD></TR>

<?php
#############################################################################
#
# Services.
#
#############################################################################
?>

<TR><TD ALIGN=left VALIGN=top><B>Services (Reference)</B>
<FORM NAME="button" METHOD="POST" ACTION="index.php3">
<?php if ($config[SHOW_SERVICES] == "YES") { ?>
  <INPUT TYPE="SUBMIT" NAME="hideservices" VALUE="Hide">
<?php } else { ?>
  <INPUT TYPE="SUBMIT" NAME="showservices" VALUE="Show">
<?php } ?>
</FORM>
</TD>
<TD>

The services table is for reference only.  You cannot add or delete
service definitions here.  Please edit /etc/services if you need to
add or change any of these.
<P>

<?php if ($config[SHOW_SERVICES] == "YES") { ?>
<TABLE BORDER=0 BGCOLOR="#EEEEEE" CELLSPACING=2 CELLPADDING=4>
  <TR ALIGN=LEFT VALIGN=TOP>
    <TD><B>Service Name</B></TD>
    <TD><B>Protocol</B></TD>
    <TD><B>Port Number</B></TD>
  </TR>

<?php

#
# Print all of the service definitions.
#
function print_service ($service,$proto,$port) {
  print "<TR VALIGN=MIDDLE ALIGN=LEFT>";
  if ($port < 1024) {
    if ($proto == "tcp") {
      $fs = "<FONT COLOR=\"#CC00CC\">";
    } elseif ($proto == "udp") {
      $fs = "<FONT COLOR=\"#EE0000\">";
    } else {
      $fs = "<FONT COLOR=\"#0000CC\">";
    }
  } else {
    if ($proto == "tcp") {
      $fs = "<FONT COLOR=\"#777700\">";
    } elseif ($proto == "udp") {
      $fs = "<FONT COLOR=\"#007777\">";
    } else {
      $fs = "<FONT COLOR=\"#0000EE\">";
    }
  }
  $fs = "<TD>" . $fs;
  $ef = "</FONT></TD>";
  print "$fs$service$ef$fs$proto$ef$fs$port$ef</TR>\n";
}

reset($services);
while ( list( $key, $val ) = each($services) ) {
  $exploded = preg_split ("/[\s\/]+/", $key);
  print_service ($exploded[0], $exploded[1], $val);
}

?>

</TABLE>
<?php } ?>

<HR></TD></TR>

<?php
#############################################################################
#
# Firewall script.
#
#############################################################################
?>

<TR><TD ALIGN=left VALIGN=top><B>Current Script</B></TD>
<TD>

<PRE>
#!/bin/sh
#
# Firewall script generated by the PHP Firewall Generator (phpfwgen).
#
# PHP Firewall Generator by Del (del@babel.com.au).  Original coding ideas
# from IPCHAINS-FIREWALL V1.6.2m by Ian Hall-Beyer (manuka@nerdherd.net)
# and various others.
#
# phpfwgen revision: $Revision: 1.9 $
#
# This script is automatically generated.  Edit at your own peril.
#
# phpfwgen (C) Del under the GPL.
#
# This script is _not_ copyright to anyone, since it was generated by
# software.
#
#############################################################################
# Initialise Firewall Configuration
#############################################################################

IPCHAINS="/sbin/ipchains"

#
# Network object definitions.
#
HIPORTS="1024:65535"

<?php
if (is_array($netobjects)) {
  reset($netobjects);
  while ( list( $key, $val ) = each( $netobjects ) ) {
    $exploded = explode (" ", $val);
    print "$key='$exploded[0]/$exploded[1]'\n";
  }
}
?>

#
# Turn on forwarding and dynamic addressing.
#
echo 1 > /proc/sys/net/ipv4/ip_forward
echo 1 > /proc/sys/net/ipv4/ip_dynaddr

#
# Turn on anti-spoofing.
#
for file in /proc/sys/net/ipv4/conf/*/rp_filter; do
  echo 1 > $file
done

#
# Set IP Masquerade timeouts to sensible defaults.
#
ipchains -M -S 7200 10 60

#
# Flush all rulesets.
#
$IPCHAINS -F input
$IPCHAINS -F output
$IPCHAINS -F forward

#
# Allow loopback interface
#
$IPCHAINS -A input -i lo -s $ALL -d $ALL -j ACCEPT
$IPCHAINS -A output -i lo -s $ALL -d $ALL -j ACCEPT

#############################################################################
# Begin Rulesets
#############################################################################

#############################################################################
# Forwarding / Masquerading
#############################################################################
#
# Turn off masquerading within masqueraded networks.
#
<?php
if (is_array($netobjects)) {
  reset($netobjects);
  while ( list($key,$val) = each($netobjects) ) {
    $exploded = explode (" ", $val);
    if ($exploded[2] == "YES") {
      printf ('$IPCHAINS -A forward -s $%s -d $%s -j ACCEPT', $key, $key);
      print "\n";
    }
  }
}
?>
#
# Turn off masquerading of the external interface.
#
$IPCHAINS -A forward -s $GATEWAYNET -d $ALL -j ACCEPT
#
# Masquerade all other networks.
#
<?php
if (is_array($netobjects)) {
  reset($netobjects);
  while ( list($key,$val) = each($netobjects) ) {
    $exploded = explode (" ", $val);
    if ($exploded[2] == "YES") {
      printf ('$IPCHAINS -A forward -s $%s -d $ALL -j MASQ', $key);
      print "\n";
      printf ('$IPCHAINS -A input -s $%s -d $ALL -j ACCEPT', $key);
      print "\n";
      printf ('$IPCHAINS -A output -s $%s -d $ALL -j ACCEPT', $key);
      print "\n";
    }
  }
}
?>
#
# Deny all other forwarding.
#
$IPCHAINS -P forward DENY

#############################################################################
# Input Rules
#############################################################################
#

<?php

if (is_array($rules)) {
  reset($rules);
  while ( list($key,$rule) = each($rules) ) {
    list ($source, $dest, $proto, $port, $action, $log) = preg_split ("/[\s]+/", $rule);
    $log=chop($log);
    print '$IPCHAINS -A input';
    if ($proto != "ALL") print " -p $proto";
    if ($proto == "icmp") {
      printf (' -s $%s', $source);
      if ($port != "ALL") print " $port";
      printf (' -d $%s', $dest);
    } else {
      printf (' -s $%s -d $%s', $source, $dest);
      if ($port != "ALL") print " $port";
    }
    print " -j $action";
    if ($log == "YES") print " -l";
    print "\n";
    #
    # insert a reverse rule for ACCEPT (tcp) packets.
    #
    if (($action == "ACCEPT") and ($proto == "tcp")) {
      print "# Reverse of the preceding rule.\n";
      print '$IPCHAINS -A input';
      print " -p $proto";
      printf (' -d $%s -s $%s', $source, $dest);
      if ($port != "ALL") print " $port";
      print " ! -y -j $action";
      if ($log == "YES") print " -l";
      print "\n";
    }
  }
}

?>

#############################################################################
# Default Rules
#############################################################################
#

#
# Default output policy: accept.
#

$IPCHAINS -A output -j ACCEPT
$IPCHAINS -P output ACCEPT

#
# Default input policy: deny and log.
#

$IPCHAINS -A input -j DENY -l
$IPCHAINS -P input DENY

</PRE>

<HR></TD></TR>
</TABLE>

</BODY>
</HTML>

